/*
 *  Psych0Day
 *  (K) 1997, 1998, 1999 by Andrew Ziem <ziem@iex.net>
 *  http://members.xoom.com/sdexter/psoft/
 *
 *     CALENDER.C -- calender code
 *
 *
 */


#include "calendar.h"



void
  show_days(void)
{

    /* not quite right, but... */
    if (opts.showdiscord || opts.showfrench || opts.showgoddesslunar ||
	opts.showgregorian || opts.showilluminati || opts.showjulian ||
	opts.showthelemic || opts.showgue || opts.showmoon)
	printf("\n");

    if (opts.showdiscord)
    {
	printf(SHOWFMT, "Discordian:");

	if (60 == greg.yday && 2 == greg.month)
	    printf("St. Tib's Day, yC %i\n", greg.year + 1166);
	else
	    printf("%s, %s %i%s, yC %i\n",

		   poee_days[poeedayweek(greg.yday) - 1],	/* day of week */
		   poee_seasons[poeeseason(greg.yday, greg.year)],	/* season */
		   poeedayseason(greg.yday, greg.year),		/* day of season */
		   ordinal_text(poeedayseason(greg.yday, greg.year)),
		   greg.year + 1166);	/* year */

    }				/* Discordian */

    if (opts.showfrench)
    {
	int fyear, fmonth, fday;


	SdnToFrench(greg.jdn, &fyear, &fmonth, &fday);

	if (fyear != 0)
	{
	    printf(SHOWFMT, "French Rep.:");
	    printf("%s %i%s, %i\n",
		   FrenchMonthName[fmonth],
		   fday,
		   ordinal_text(fday),
		   fyear);
	}
    }				/* French Republican */



    if (opts.showgoddesslunar)
    {
	glcdate glc;


	printf(SHOWFMT, "Goddess Lunar:");
	glc.jdn = greg.jdn;
	jdn_to_goddess_date(&glc);
	printf("%s %d%s, %ld\n",
	       glc_months[glc.month - 1],
	       glc.day,
	       ordinal_text(glc.day),
	       glc.year);

    }				/* Goddess Lunar */


    if (opts.showgue)
    {
	printf(SHOWFMT, "Great Empire:");
	printf("%s, %s %i%s, %i\n",
	       gue_days[greg.wday],
	       gue_months[greg.month - 1],
	       greg.mday,
	       ordinal_text(greg.mday),
	       abs(greg.year - 1027));

    }				/* Great Underground Empire */


    if (opts.showgregorian)
    {
	printf(SHOWFMT, "Gregorian:");
	printf("%s, %s %i%s, %s%i%s (day #%i, week #%i)\n",
	       gregorian_days[greg.wday],
	       gregorian_months[greg.month - 1],
	       greg.mday,
	       ordinal_text(greg.mday),
	       greg.year > 0 ? "AD " : "",
	       abs(greg.year),
	       greg.year <= 0 ? " BC" : "",
	       greg.yday,
	       weeknum(greg.year, greg.month, greg.mday));

    }				/* Gregorian */


    if (opts.showilluminati)
    {
	printf(SHOWFMT, "Illuminati:");

	if (greg.yday == 60 && greg.month == 2)
	    printf("Heiligefliegendekindersheissetag, AL %i\n", greg.year + 4000);
	else
	    printf("%s %i%s, AL %i\n",
		   ill_seasons[poeeseason(greg.yday, greg.year)],	/* season */
		   poeedayseason(greg.yday, greg.year),		/* day of season */
		   ordinal_text(poeedayseason(greg.yday, greg.year)),
		   greg.year + 4000);	/* year */

    }				/* Illuminati */


    if (opts.showjulian)
    {
	int jday, jmonth, jyear;
	char sJDN[10];


	printf(SHOWFMT, "Julian:");

	SdnToJulian(greg.jdn, &jyear, &jmonth, &jday);

	commafmt(sJDN, 10, greg.jdn);
	printf("%s %i%s, %i (JDN %s)\n",
	       gregorian_months[jmonth - 1],
	       jday,
	       ordinal_text(jday),
	       jyear,
	       sJDN);

    }				/* Julian */

    if (opts.showjusanotoron)
    {
	unsigned int jyear, jyday;
	char s[10];


	printf(SHOWFMT, "Jusanotoron:");
	jusanotoron_date(greg.year, greg.yday, &jyear, &jyday);
	printf("%s %i%s, %s\n",
	       poee_seasons[poeeseason(jyday, greg.year)],
	       poeedayseason(jyday, greg.year),
	       ordinal_text(poeedayseason(jyday, greg.year)),
	       lstr(jyear, s, 10));


    }				/* Jusanotoron */


    if (opts.showmoon)
    {
	printf(SHOWFMT, "Moon:");
	if (4 == Moon_Phase(greg.year, greg.yday))
	{
	    /* full moon */
	    printf("%s (%s)\n", MoonPhaseText[Moon_Phase(greg.year, greg.yday)], moons[greg.month - 1]);
	}
	else
	{
	    printf("%s\n", MoonPhaseText[Moon_Phase(greg.year, greg.yday)]);
	}

    }				/* lunar calendar */


    if (opts.showthelemic)
    {
	char yearbuf[10], subyearbuf[10], stmp[10];
	int y, sy;


	printf(SHOWFMT, "Thelemic:");

	/* calculate Thelemic year and "subyear" */
	y = (greg.year - 1904) / 22;
	sy = (greg.year - 1904) % 22 - 1;

	long2roman(abs(y), yearbuf, 10);

	if (0 == sy)
	    strcpy(subyearbuf, "");
	else
	{
	    strcpy(stmp, strlwr(long2roman(abs(sy), subyearbuf, 10)));
	    sprintf(subyearbuf, ":%s", stmp);
	}

	printf("%s %i%s, %sAnno %s%s\n",
	       gregorian_months[greg.month - 1],
	       greg.mday,
	       ordinal_text(greg.mday),
	       y > 0 ? "" : "Ante ",
	       yearbuf,
	       subyearbuf);

    }				/* Thelemic */

}				/* show_calendars() */
